#ifndef _MK_AIO_DEFINES_H_
#define _MK_AIO_DEFINES_H_

//  AI ġ ε  //
typedef struct{
	HANDLE hDevice; // PC=>Device handle, DSP=>Base address
	t_i32 nNumAi;
	t_i32 nAiIni;
	struct{
		t_ui32 Id:	4; // Device ID
		t_ui32 Ver:	4; // H/W Version
		t_ui32 ModId: 4; // Module Id (͸ ġ  )
		t_ui32 ModType: 2; // Module Type ( ,  , ĸ  reserved)
		t_ui32 Rsv:	18;
	}u;
	t_i32 nReserved[3];
		
}TAiDevice;

//  AO ġ ε  //
typedef struct{
	HANDLE hDevice; // PC=>Device handle, DSP=>Base address
	t_i32 nNumAo;
	t_i32 nAoIni;
	t_ui32 dwAoStates;
	struct{
		t_ui32 Id:	4; // Device ID
		t_ui32 Ver:	4; // H/W Version
		t_ui32 ModId: 4; // Module Id (͸ ġ  )
		t_ui32 ModType: 2; // Module Type ( ,  , ĸ  reserved)
		t_ui32 Rsv:	18;
	}u;
	t_i32 nReserved[2];	
}TAoDevice;

void aioBootup(void);
t_i32 aioGetVersion(void);

TAiDevice* aiGetDeviceDesc (t_ui16 uDevIdx);
TAoDevice* aoGetDeviceDesc (t_ui16 uDevIdx);

t_bool	aiInitial (t_ui16 nNumDevs, TAiDevice aAiDevInfo[]);
t_bool	aoInitial (t_ui16 nNumDevs, TAoDevice aAoDevInfo[]);

t_i32	aiGetNumDevice (void);
t_bool	aiIsValidChan(t_ui16 nAiChan);
t_ui16	aiGetNumChannels();

t_i32	aoGetNumDevice (void);
t_bool	aoIsValidChan(t_ui16 nAoChan);
t_ui16	aoGetNumChannels();

//   Լ
void	_aoSetChLED(t_ui32 nChannel, t_bool bState);
void	_aiSetChLED(t_ui32 nChannel, t_bool bState);

t_i32 aiSetVoltRangeMode(t_ui16 nChannel, t_i32 nMode); // nMode  mk_aio.c  Լպκп  .
t_i32 aiGetVoltRangeMode(t_ui16 nChannel, t_i32* pnMode);
t_i32 aiGetRangeDigit(t_ui16 nChannel, t_i32* Dmin, t_i32* Dmax);
t_i32 aiGetDigit(t_ui16 nChannel, t_i32* pDigit);
t_i32 aiGetVolt(t_ui16 nChannel, t_f32* pfVolt);
t_i32 aiGetCurrent(t_ui16 nChannel, t_f32* pfCurrent);

t_i32 aoOutDigit(t_ui16 nChannel, t_i32 OutDigit);
t_i32 aoOutVolt(t_ui16 nChannel, t_f32 OutVolt);
t_i32 aoOutCurrent(t_ui16 nChannel, t_f32 OutCurrent);

#if (_PLATFORM==PLF_RTEX) //@@@@@@@@@@@@@@@@@ #1
extern TAiDevice g_aAiDev[NUM_MAX_AIOMODULE];
extern TAoDevice g_aAoDev[NUM_MAX_AIOMODULE];
#endif //@@@@@@@@@@@@@@@@@ #1

#endif
