//================================================================================================================
// [mk_cnet.h] : 
// - Version: 1.0.0.0
// - Update Data: 2010/08/11
// - Created by HJO
// -. Revision history:
//   1 <Ver 1.0.0.0>: S/W  ̺귯  Ӱ 
//   2010.8.11 
//	 I/O   üũϴ Լ ߰Ͽϴ. 
//   Լ̸ : cnetGetComIoErrSts(); 
//   ϰ :  - 0,  - 1
//    :  ߻Ͽ     IO  簳 ̽ ĵ ٽ ؾ մϴ. 
//          罺ĵ ʰ IO  簳ϸ  ° ʱȭ  ʽϴ.
//================================================================================================================
#ifndef _MK_CNET_DEFINES_H_
#define _MK_CNET_DEFINES_H_

#define BAUD_2_5M	0x0	// 2.5 Mbps
#define BAUD_05M    	0x4	// 5 Mbps
#define BAUD_10M    	0x8	// 10Mbps
#define BAUD_20M    	0xC	// 20Mbp

// ---------------------------------------------------------------------------
// Device Information
// ---------------------------------------------------------------------------
enum {DI_00_DO_32, DI_08_DO_08, DI_16_DO_16, DI_16_DO_00, DI_32_DO_00, DI_00_DO_16};

// ---------------------------------------------------------------------------
//  (̺)  
// ---------------------------------------------------------------------------
#define CNET_SLAVE_NUM	32

// ---------------------------------------------------------------------------
// Channel Logic
// ---------------------------------------------------------------------------
#ifndef LOGIC_A
#define LOGIC_A 	0
#endif

#ifndef LOGIC_B
#define LOGIC_B 	1
#endif

// ---------------------------------------------------------------------------
// Status Register  Ȯ õ ȸ 
// ---------------------------------------------------------------------------
#define RETRYNUM	3

// ---------------------------------------------------------------------------
// Ʈ ũ
// ---------------------------------------------------------------------------
#define SETBIT(v,n,s)	if(s) (v)|=(0x1<<(n)); else (v)&=~(1<<(n))
#define GETBIT(v,n)	(((v)>>(n))&0x1)

typedef struct
{
	unsigned int IOAddr:9;				// G9001  ϴ ּ
	unsigned int NodeType:3;			//( 000-00_32, 001-8_8, 010-16_16, 011-16_00, 100-32_00, 101-00_16)	
	unsigned int IOState:2;				//(0-Out, 1-In, 2-I/O)
	unsigned int DeviceUse:1; 			// 尡   ˸ ÷
	unsigned int nInChannels:6; 			// Էä 
	unsigned int nOutChannels:6; 			//  ä 
	unsigned int nGlobalStartChannel_IN:12; 	// 忡 Էä Ŭιäιȣ
	unsigned int nGlobalStartChannel_OUT:12; 	// 忡 ä Ŭιäιȣ
	unsigned int nInLogic:32; 			// Էä  
	unsigned int nOutLogic:32; 			// ä  
	unsigned int Reserved:1;
} TCNETMSlave;

typedef struct
{
	TCNETMSlave Slave[CNET_SLAVE_NUM];
} TCNETMSlaveInfo;

//  DIO ġ ε  //
typedef struct{
	HANDLE hDevice; // PC=>Device handle, DSP=>Base address
	t_i32 nNumDio, nNumDi, nNumDo;
	t_i32 nNumSlave;
	t_i32 nNumSlaveType[16];
	TCNETMSlaveInfo	si;
	struct{
		t_ui32 Id:	4; // Device ID
		t_ui32 Ver:	4; // H/W Version
		t_ui32 ModId: 4; // Module Id (͸ ġ  )
		t_ui32 Rsv:	20;
	}u;
}TCNDioDevice;

t_i32 cnetdioBootup();
t_i32 cnetdioGetVersion(void);
TCNDioDevice * cnetdioGetDeviceDesc (t_ui16 uDevIdx);
void cnetGetSlaveTotal(t_ui16 uMasterModIdx, t_i16 *pSlaveTotNum);

t_bool	cnetdiIsValidChan(t_ui16 nDiChan);
t_ui16	cnetdiGetNumChannels();
t_bool	cnetdiGetLogic(t_ui16 nChannel);
void	cnetdiSetLogic(t_ui16 nChannel, t_bool bLogic);
t_ui32	cnetdiGetLogicMulti(t_ui16 nIniChan, t_ui16 nNumChan);
void	cnetdiSetLogicMulti(t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwLogicMask);
t_i16	cnetdiGetOne (t_ui16 nChannel);
t_i32	cnetdiGetMulti (t_ui16 nIniChan, t_ui16 nNumChan);

t_bool	cnetdoIsValidChan(t_ui16 nDoChan);
t_ui16	cnetdoGetNumChannels();
t_bool	cnetdoGetLogic(t_ui16 nChannel);
void	cnetdoSetLogic(t_ui16 nChannel, t_bool bLogic);
t_ui32	cnetdoGetLogicMulti(t_ui16 nIniChan, t_ui16 nNumChan);
void	cnetdoSetLogicMulti(t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwLogicMask);
void	cnetdoPutOne (t_ui16 nChannel, t_bool bState);
t_i16	cnetdoGetOne (t_ui16 nChannel);
void	cnetdoPutMulti (t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwStates);
t_i32	cnetdoGetMulti (t_ui16 nIniChan, t_ui16 nNumChan);

void	cnetdioInitial (t_ui16 nNumDevs, TCNDioDevice aDioDevInfo[]);
t_i32	cnetdioGetNumDevice (void);
//t_i32 	cnetdioGetNumDevice_Ex (t_ui16 nModType); // 0: ceD16CM, 1: ceDI32N, 2: ceDO32N
t_i32 	cnetdioGetNumSlave (void);
t_i32 	cnetdioGetNumSlave_Ex (t_ui16 nModType);
t_ui16	cnetdioGetNumChannels();
t_bool	cnetdioGetIomode (t_ui16 nChannel);
void	cnetdioSetIomode (t_ui16 nChannel, t_bool nInOutMode);
t_ui32	cnetdioGetIomodeMulti (t_ui16 nIniChan, t_ui16 nNumChan);
void	cnetdioSetIomodeMulti (t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwIOMM);
t_bool	cnetdioGetLogic (t_ui16 nChannel);
void	cnetdioSetLogic (t_ui16 nChannel, t_bool bLogic);
t_ui32	cnetdioGetLogicMulti (t_ui16 nIniChan, t_ui16 nNumChan);
void	cnetdioSetLogicMulti (t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwLogicMask);
void	cnetdioPutOne (t_i16 nChannel, t_i16 bState);
t_bool	cnetdioGetOne (t_ui16 nChannel);
void	cnetdioPutMulti (t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwStates);
t_ui32	cnetdioGetMulti (t_ui16 nIniChan, t_ui16 nNumChan);

t_i16	cnetDoGetMultiEx(t_ui16 uMasterModIdx, t_i16 NodeID, t_i16 nIniChannel, t_i16 nChannels, t_i16 * OutStates);
t_i16	cnetDoPutMultiEx(t_ui16 uMasterModIdx, t_i16 NodeID, t_i16 nIniChannel, t_i16 nChannels, t_i16 OutStates);
t_i16	cnetDiGetMultiEx(t_ui16 uMasterModIdx, t_i16 NodeID, t_i16 nIniChannel, t_i16 nChannels, t_i16 * InStates);

void cnetSetInterLock(t_i32 isEnable);
t_i32 cnetGetInterLock();

//////////////////////////////////////////////////////////////////////////////////
//2010.9.9 ߰ 
//   üũ Լ
t_i32 cnetGetErrState();

// 2011.02.01 Լ Ķ ߰.
t_i32 cnetGetErrState2(t_ui16 uMasterModIdx, t_bool bAutoRecovery);

//2011.02.01 ߰
//  (RESET, RESTART)
t_i16 cnetRecovery(t_ui16 uMasterModIdx);

//2012.11.01 SEMES 
t_i16 cnetSetComSpeed(t_i16 nStatus);
t_i32 cnetWaitDone();
t_ui32 _ccGnUpdateError(HANDLE hDevice, t_i16 isErrClr);
t_ui32 cnetIsError(t_i16 isErrClr);
t_char *cnetGetErrString();

// ---------------------------------------------------------------------------
//  üũ Լ 
//
// Return: 

// cnetGetErrState()  cnetGetErrState2() Լ    ڵ.
//	-1001 : ĵ  
// 	-1002 :   
// 	-1003 : IO    
//  -1004 : IO  ߴ  
// 	-1005 : IO   
// 	-1006 : GnSetComSpeed Լ ID_SW  0 Ͽϴ.
//	-1007 : GnSetComSpeed Լ nStatus  0,4,8,12 ̿ η Ͽϴ.
//  -1008 : DIO Multi  Լ ä   32 ū  Ͽϴ. 
//  -1009 : DIO Multi  Լ äιȣ   ϴ.  
//  -1010 : DIO  Լ ä ȣ    Ͽϴ. 
// 	-1011 : DIO  Լ Node ȣ    Ͽϴ. 
//  -1012 : DI  Լ Է Node ƴ Node ȣ  Ͽϴ. 
//  -1013 : DO  Լ  Node ƴ Node ȣ  Ͽϴ. 

// cnetGetErrState2() Լ  ϴ ڵ.
//  -1014 : Data or System communication error (G9001  Ʈ 1-22  )
//  -1015 : Local Device Reception Processing Error (G9001  Ʈ 1-22  )
//  -1016 : CPU Access  (G9001  Ʈ 1-22  )
//  -1500 ; I/O Communication Start °   Ǯȴ.(Start ° )
//  -2000 ; Invalid Module Idx
//  -9999 : Unknown Error
// ---------------------------------------------------------------------------

// IO   üũ Լ  return  : 0, return  : 1 
t_i32 cnetGetComIoErrSts();
//   Do, DI ä  ȯ Լ 
void cnetGetChannelsInNode(t_ui16 DevIdx, t_ui16 NodeIdx, t_ui32 * DoNums, t_ui32 * DiNums);

//////////////////////////////////////////////////////////////////////////////////
// not in use
// Data Output  üũ Լ  return  : 0, return  : 1 
t_i32 _cnetGetComSendErrSts();
// 32Ʈ    Լ. return  : 0 ,  :  尡 1 .
t_ui32 _cnetGetComNodeSts(t_ui16 GrpIdx);
//    üũ Լ  return  : 0,  - ڵ ȯ
t_i32 _cnetCheckErrSts();
//////////////////////////////////////////////////////////////////////////////////

//  Լ : Ƿ  .
t_i16 ccGnSetComSpeed(t_i16 nStatus);
t_i32 _Check_EIOE(HANDLE hDevice);
t_i16 _DataBitOrCalc(t_i16 nData);
t_i32 _ccGnMakeErrCodeLocal(t_i16 nCodeType, t_i16 nFuncType, t_i16 nInOut, t_i16 nChannel, t_i16 nNodeID, t_i16 nReason);
t_i32 _ccGnMakeErrCode(t_i16 nCodeType, t_i16 nFuncType, t_i16 nInOut, t_i16 nChannel, t_i16 nReason);
void _ConvertToGlobalChannel(t_ui16 uMasterModIdx, t_i16 nNodeID, t_i16 nChannel, t_i16 *GlobalChannel, t_byte IsInputChannel);
void _ConvertToNodeChannel(t_ui16 uMasterModIdx, t_i16 nGlobalChannel, t_i16 *NodeID, t_i16 *Channel, t_byte IsInputChannel);
TCNETMSlaveInfo * _GetSlaveInfo(t_ui16 uMasterModIdx);

t_ui16 _G9001_Read_8bit(HANDLE hDevice, t_ui16 Address);
t_ui16 _G9001_Read_16bit(HANDLE hDevice, t_ui16 Address);
void _G9001_Write_8bit(HANDLE hDevice, t_ui16 Address, t_ui16 wdata);
void _G9001_Write_16bit(HANDLE hDevice, t_ui16 Address, t_ui16 wdata);

t_i32 _ccGnGetLastError();
//////////////////////////////////////////////////////////////////////////

t_i16 _ccGnStart(t_ui16 uMasterModIdx);			//   (zero based)
t_i16 _ccGnStop(t_ui16 uMasterModIdx);			//  ߴ (zero based)
t_i16 _ccGnReset(t_ui16 uMasterModIdx);			//  (zero based)

t_i16 _ccGnGetDoTotal(t_ui16 uMasterModIdx, t_i16 * pTotalDIChannelNum);
t_i16 _ccGnGetDiTotal(t_ui16 uMasterModIdx, t_i16 * pTotalDIChannelNum);
t_i16 _ccGnGetSlaveTotal(t_ui16 uMasterModIdx, t_i16 *pTotalDeviceNum);
t_i16 ccDoGetMultiEx(t_ui16 uMasterModIdx, t_i16 NodeID, t_i16 nIniChannel, t_i16 nChannels, t_i16 * OutStates);
t_i16 ccDoPutMultiEx(t_ui16 uMasterModIdx, t_i16 NodeID, t_i16 nIniChannel, t_i16 nChannels, t_i16 OutStates);
t_i16 ccDoGetMulti(t_ui16 uMasterModIdx, t_i16 nIniGlobalChannel, t_i16 nChannels, t_i16 * OutStates);
t_i16 ccDiGetMultiEx(t_ui16 uMasterModIdx, t_i16 NodeID, t_i16 nIniChannel, t_i16 nChannels, t_i16 * InStates);
t_i16 ccDoPutMulti(t_ui16 uMasterModIdx, t_i16 nIniGlobalChannel, t_i16 nChannels, t_i16 OutStates);
t_ui16 ccGetSlaveType(HANDLE uMasterModIdx, t_i16 NodeID);
t_i16 ccDoPutOne(t_i16 nGlobalChannel, t_i16 OutState);
t_i16 ccDoGetOne(t_i16 nGlobalChannel, t_i16 * OutState);
t_i16 ccDiGetOne(t_i16 nGlobalChannel, t_i16 * OutState);
t_i16 Get_OutOneNode(t_ui16 uMasterModIdx, t_i16 nIniGlobalChannel, t_i16 *DoStates, t_i16 *ReadChanCnt);
t_i16 ccDiGetMulti(t_ui16 uMasterModIdx, t_i16 nIniGlobalChannel, t_i16 nChannels, t_i16 * InStates);

//////////////////////////////////////////////////////////////////////////
// Error  Functions
//////////////////////////////////////////////////////////////////////////
t_i16 _ccGnGetCodeType(t_i32 nErrCode);
t_i16 _ccGnGetFuncType(t_i32 nErrCode);
t_i16 _ccGnGetErrorIO(t_i32 nErrCode);
t_i32 _ccGnGetErrorLocalChannel(t_ui16 uMasterModIdx, t_i32 nErrCode);
t_i32 _ccGnGetErrorChannel(t_ui16 uMasterModIdx, t_i32 nErrCode);
t_i32 _ccGnGetErrorNodeID(t_ui16 uMasterModIdx, t_i32 nErrCode);
t_i16 _ccGnGetErrorReason(t_i32 nErrCode);
// ---------------------------------------------------------------------------
// ڵ忡  λ° ȯϴ Լ
//
// Params: 
// 	nErrCode		:  ȮϷ Error Code
// Return: 
// 	nReason
// 	0x10 :   ν . ReadID() Լ  0x19  ƴϸ.
// 	0x20 : ĵ . Status Register  (CEND=1, EDTE=0) ƴϸ .
// 	0x21 :   . Status Register  RBSY  1̸ .
// 	0x22 : IO   . Status Register  SBSY  0̸ .
// 	0x23 : IO ߴ  . Status Register  SBSY  1̸ .
// 	0x31 : IO . Status Register  EIOE 1̸ .  ߻ ȣ 
// 	0x40 : Set_Device Ķ, GnSetComSpeed Ķ ID_SW 0  .
// 	0x41 : GnSetComSpeed Ķ nStatus  0,4,8,12 ̿   .
// 	0x42 : DIO Multi  Լ äΰ ĶͰ 32 ū   .
// 	0x43 : DIO Multi  Լ äιȣ üäιȣ ū  .
// 	0x44 : DIO Լ äιȣ ĶͰ  ʴ äιȣ  .
// 	0x45 : DIO Լ ȣ ĶͰ  ʴ ȣ  ( ʴ ).
// 	0x46 : DI Լ ش 尡 Է 尡 ƴ  .
// 	0x47 : DO Լ ش 尡  尡 ƴ  .
// ---------------------------------------------------------------------------

#endif
