//================================================================================================================
// [mk_common.h]: 
// - Version: 1.0.0.2
// - Update Data: 2007/09/17
// - Created by OYS
//================================================================================================================

#ifndef _MK_COMMON_DEFINES_H_
#define _MK_COMMON_DEFINES_H_

#include <string.h> 
#include <math.h> 
#include <stdlib.h>  
#include <stdio.h>

// System platform Definition //
#define PLF_miCUBE		0
#define PLF_miCUBE_E	1
#define PLF_EtherIP_1	2 // using ceNM_SE
#define PLF_SIMULINE_1	3 // Simuline motion control board
#define PLF_EtherIP_2	4 // using ceNM_PE 
#define PLF_RTEX		5 // COMI-LX520
#define _PLATFORM		PLF_EtherIP_2   // Active Platform

#if	(_PLATFORM==PLF_miCUBE || _PLATFORM==PLF_miCUBE_E)
/* Boot Loader for Startup */
asm("	.text				");
asm("	.global	_c_int00	");
asm("	BR		_c_int00	");
#define	INT0	1
#define	INT1	2
#define	INT2	3
#define	INT3	4
#define	XINT0	5
#define	RINT0	6
#define	TINT0	9
#define	TINT1	10
#define	DINT0	11
#define	DINT1	12

#elif (_PLATFORM==PLF_EtherIP_1)
#include "DSP281x_Device.h"

#elif (_PLATFORM==PLF_RTEX)
#include "DSP2833x_Device.h"
#else

#endif

enum {SOCK_SERIAL, SOCK_ETHERNET, SOCK_USB};
enum {	DEV_ID_INVALID=-1, DEV_ID_AI04=0x10, DEV_ID_AI08=0x11, DEV_ID_AO02=0x1A, DEV_ID_AO04=0x1B,
		DEV_ID_D16CM=0x14, DEV_ID_DI32=0x13, DEV_ID_DO32=0x12,
		DEV_ID_MC02P=0x15, DEV_ID_MC04P=0x16,
		DEV_ID_CN08=0x1C,
		DEV_ID_SC04=0x1E,
		DEV_ID_CM01A=0x19 };

#define INVALID_HANDLE_VALUE	0xffffffff

#define false	0
#define true 	1

#ifndef FALSE
#define FALSE	0
#endif

#ifndef TRUE
#define TRUE	1
#endif

#define OFF		0
#define ON		1

#ifndef NULL
 #define NULL	0
#endif


#if	(_PLATFORM==PLF_miCUBE || _PLATFORM==PLF_miCUBE_E) //@@@@@@@@@@@@@@@@@ #1

typedef char			t_bool;
typedef char 			BOOL;
typedef char			t_char;
typedef unsigned char	t_byte;
typedef unsigned char	u_char;
typedef unsigned char	UCHAR;
typedef unsigned char	t_uchar;
typedef unsigned char	SOCKET;
typedef double 			t_float32;
typedef double			t_f32;
typedef t_uchar			t_ui8;
typedef t_char			t_i8;
typedef long double 	t_float40;
typedef unsigned int 	ULONG;
typedef unsigned int 	UINT;
typedef unsigned char 	BYTE;
typedef unsigned short	u_short;	// 16-bit value
typedef unsigned int	u_int;		// 32-bit value
typedef unsigned long	u_long;		// 32-bit value
typedef unsigned int	t_ui32;
typedef int				t_i32;
typedef short			t_i16;
typedef unsigned short	t_ui16;
typedef unsigned int	HANDLE;
typedef unsigned int 	DWORD;
typedef unsigned short 	WORD;
typedef unsigned int (*TfpGetTimerTick) (void);

#define	Int_enable()	asm("		OR	2000H,ST	");  // enable all interrupt
#define	Int_disable()	asm("		ANDN	2000H,ST	"); // disable all interrupt
#define	Int_clear()		asm("		LDI	0000H,IE	"); // clear all interrupt

#define Outp32(cs, ofs, outval) *((volatile t_i32*)cs + (ofs)) = outval
#define Inp32(cs, ofs)	(*((volatile t_i32*)(cs) + (ofs)))
#define Outp16(cs, ofs, outval) *((volatile t_i16*)cs + (ofs)) = (outval) & 0xffff
#define Inp16(cs, ofs)	(*((volatile t_i16*)(cs) + (ofs)) & 0xffff)
#define Outp8(cs, ofs, outval) *((volatile t_byte*)cs + (ofs)) = (outval) & 0xff
#define Inp8(cs, ofs)	(*((volatile t_byte*)(cs) + (ofs)) & 0xff)

#elif (_PLATFORM==PLF_EtherIP_1) //@@@@@@@@@@@@@@@@@ #1

typedef char			t_bool;
typedef char 			BOOL;
typedef char			t_char;
typedef unsigned char	t_byte;
typedef unsigned char	u_char;
typedef unsigned char	UCHAR;
typedef unsigned char	t_uchar;
typedef unsigned char	SOCKET;
typedef double 			t_float32;
typedef double			t_f32;
typedef t_uchar			t_ui8;
typedef t_char			t_i8;
typedef unsigned long	ULONG;
typedef unsigned int	t_ui16;
typedef int				t_i16;
typedef unsigned long	t_ui32;
typedef long			t_i32;
typedef unsigned long	HANDLE;
typedef unsigned long	DWORD;
typedef unsigned int 	UINT;
void Int_enable();
void Int_disable();
void Int_clear();

#define Outp32(cs, ofs, outval) *((volatile t_i32*)cs + (ofs)) = outval
#define Inp32(cs, ofs)	(*((volatile t_i32*)(cs) + (ofs)))
#define Outp16(cs, ofs, outval) *((volatile t_i16*)cs + (ofs)) = (outval) & 0xffff
#define Inp16(cs, ofs)	(*((volatile t_i16*)(cs) + (ofs)) & 0xffff)
#define Outp8(cs, ofs, outval) *((volatile t_byte*)cs + (ofs)) = (outval) & 0xff
#define Inp8(cs, ofs)	(*((volatile t_byte*)(cs) + (ofs)) & 0xff)

#elif (_PLATFORM==PLF_EtherIP_2) //@@@@@@@@@@@@@@@@@ #1

void _Int_disable(void);
void _Int_enable(void);

typedef char			t_char; 
typedef unsigned char	t_byte;
typedef unsigned char	t_uchar;
typedef t_byte			t_bool;
typedef t_char			t_i8;
typedef t_uchar			t_ui8;
typedef unsigned short	t_ui16;
typedef short			t_i16;
typedef unsigned int	t_ui32;
typedef int				t_i32;
typedef float			t_f32;
typedef double			t_f64;
typedef t_ui32			HANDLE;
typedef t_uchar			SOCKET;

typedef char 			BOOL;
typedef unsigned char	UCHAR;
typedef double 			t_float32;
typedef unsigned long	ULONG;
typedef unsigned long	DWORD;
typedef unsigned int 	UINT;

typedef unsigned char 	BYTE;
typedef unsigned short 	WORD;

///////////////////////////////////////////////////////////////
#define	Int_enable()	_Int_enable()
#define	Int_disable()	_Int_disable()
#define	Int_clear()

#define Outp32(cs, ofs, outval) *((volatile t_i32*)cs + (ofs)) = outval
#define Inp32(cs, ofs)	(*((volatile t_i32*)(cs) + (ofs)))
#define Outp16(cs, ofs, outval) *((volatile t_i32*)cs + (ofs)) = (outval) & 0xffff
#define Inp16(cs, ofs)	(*((volatile t_i32*)(cs) + (ofs)) & 0xffff)
#define Outp8(cs, ofs, outval) *((volatile t_i32*)cs + (ofs)) = (outval) & 0xff
#define Inp8(cs, ofs)	(*((volatile t_i32*)(cs) + (ofs)) & 0xff)

#elif (_PLATFORM==PLF_RTEX) //@@@@@@@@@@@@@@@@@ #1
typedef char			t_bool;
typedef char 			BOOL;
typedef char			t_char;
typedef unsigned char	t_byte;
typedef unsigned char	u_char;
typedef unsigned char	UCHAR;
typedef unsigned char	t_uchar;
typedef unsigned char	SOCKET;
typedef double 			t_float32;
typedef double			t_f32;
typedef t_uchar			t_ui8;
typedef t_char			t_i8;
typedef unsigned char  *PBYTE;
typedef unsigned long	ULONG;
typedef unsigned int	t_ui16;
typedef int				t_i16; 
typedef unsigned long	t_ui32;
typedef long			t_i32;
typedef unsigned long	HANDLE;
typedef unsigned long	DWORD;

typedef enum _TLEDStatus{
	ALED_OFF=0, ALED_SS, ALED_LSS, ALED_LL, ALED_ON, ELED_OFF=8, ELED_SS, ELED_LSS, ELED_LL, ELED_ON
}TLEDStatus;

// LED Status Index List
typedef enum _TLEDStatusIdx{
	LEDSIDX_NM_DISABLE=1, LEDSIDX_NM_DUPID, LEDSIDX_NM_WRONGID, LEDSIDX_NM_FWUP,
	LEDSIDX_MO_DISABLE, LEDSIDX_MO_WRONGID, LEDSIDX_MO_COMMERR, LEDSIDX_MO_COMMOK, LEDSIDX_MO_RDY
}TLEDStatusIdx;

typedef enum { CPU_MODULE_ERR, CPU_MODULE_ACT, DIO_MODULE_ERR, DIO_MODULE_ACT, AI_MODULE_ERR, AI_MODULE_ACT, AO_MODULE_ERR, AO_MODULE_ACT, CNT_MODULE_ERR, CNT_MODULE_ACT, SER_MODULE_ERR, SER_MODULE_AC

// Base address of each section
#define AM_RS232	0xf00000
#define AM_ETHER	0x2000
#define AM_EBUS		0x200000
#define AM_SLOT_ADDR_OFS	0x100
#define NUM_MAX_AXES_PERMOD		2
#define NUM_MAX_COMMMODULE		10
#define NUM_MAX_MOTIONMODULE	10
#define NUM_MAX_DIOMODULE		10
#define NUM_MAX_AIOMODULE		10
#define NUM_MAX_CNTMODULE		10
#define NUM_MAX_SERMODULE		10
#define MAX_N_AXES	18 // defines for motion control
#define MAX_N_DIO_CHAN	160 // maximum number of DIO channels
#define FW_UPDATE_CHECKSIGN	0xABCD1234
#define FW_VERSION		0x01141108

#define Outp32(cs, ofs, outval) *((volatile t_i32*)cs + (ofs)) = outval
#define Inp32(cs, ofs)	(*((volatile t_i32*)(cs) + (ofs)))
#define Outp16(cs, ofs, outval) *((volatile t_i16*)cs + (ofs)) = (outval) & 0xffff
#define Inp16(cs, ofs)	(*((volatile t_i16*)(cs) + (ofs)) & 0xffff)
#define Outp8(cs, ofs, outval) *((volatile t_byte*)cs + (ofs)) = (outval) & 0xff
#define Inp8(cs, ofs)	(*((volatile t_byte*)(cs) + (ofs)) & 0xff)

extern void DSP28x_usDelay(t_ui32 Count);
#define Delay_us(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
#define Delay_ms(ms) Delay_us((ms)*1000L)
void Delay_100ns(void);
void Delay_200ns(void);

#define CPU_RATE    6.667L   // for a 150MHz CPU clock speed (SYSCLKOUT)

#endif //@@@@@@@@@@@@@@@@@ #1

// IEEE Floating Point Format //
typedef union{
	struct{
		t_ui32 f:	23;
		t_ui32 e:	8;
		t_ui32 s:	1;
	}b;
	t_ui32 v;
}TIeeeFloat;

// TMS320CVC33 Floating Point Format //
typedef union{
	struct{
		t_ui32 f:	23;
		t_ui32 s:	1;
		t_ui32 e:	8;
	}b;
	t_ui32 v;
}TTms32Float;

typedef union{
	struct{
		t_ui32 b4: 8;
		t_ui32 b3: 8;
		t_ui32 b2: 8;
		t_ui32 b1: 8;
	}addr_1;
	t_ui32 addr_4;
}TSockAddr;

// added on 2008/09/22 by johyun
// SC04A Device Info //
typedef struct{
	HANDLE hDevice; // PC=>Device handle, DSP=>Base address
	t_i32 nNumSerPort;
	t_i32 nSerIni;
	struct{
		t_ui32 Id:	4; // Device ID
		t_ui32 Ver:	4; // H/W Version
		t_ui32 ModId: 4; // Module Id (Lottery Switch)
		t_ui32 ModType: 4;
		t_ui32 Rsv:	16;
	}u;
	t_i32 nReserved[3];
		
}TSerDevice;


t_i32 fwlibGetVersion(void);
t_i32 gpioGetVersion(void);
t_i32 commonGetVersion(void);
t_i32 flsGetVersion(void);

#define Long2Float(l) (*((t_f32*)(&(l))))
#define Float2Long(f) (*((t_i32*)(&(f))))

// v:target variable, n:bit #, s:state	//
#define SetBit(v,n,s)  if(s) v|=((t_ui32)1<<(n)); else v&=~((t_ui32)1<<(n));
#define RoundOff(v) ((t_ui32)((v)+0.5))
#define IsValidIOCH(ch, maxch) (ch >= 0 && ch < maxch)

t_ui32 atoh(t_char *str);
t_ui16 Hex2Str(t_ui32 dwValue, t_char *pszBuf, t_i16 nWidth, t_bool bFillZero, t_bool bCapital);
t_ui32 FltCnvt_I2T(t_ui32 dwIeee_v); // convert float data from IEEE to TI format
t_ui32 FltCnvt_T2I(t_ui32 dwTms_v); // convert float data from TI to IEEE format

void mkcBootup(void);
t_ui32 mkcTimerTick(void);
void mkcTimerTick_Set(t_ui32 dwSetValue);
void mkcTimerCallback(void);

void ResetMotionModule(t_bool bStopMotion, t_bool bDecel);
void ResetDIOModule(void);
void ResetAIOModule(void);
void ResetCntrModule(void);

#if	(_PLATFORM==PLF_miCUBE || _PLATFORM==PLF_miCUBE_E) // @@@@@@@@@@@@@@@@ #2
extern void Delay_us(int us); // in mk_asmfunc.asm
#define Delay_ms(ms) Delay_us((ms)*1000)
inline void Delay_100ns();
inline void Delay_200ns();

#elif (_PLATFORM==PLF_EtherIP_1) // @@@@@@@@@@@@@@@@ #2
#define CPU_RATE    6.667L   // for a 150MHz CPU clock speed (SYSCLKOUT)

// DO NOT MODIFY THIS LINE.  
extern void DSP28x_usDelay(Uint32 Count);
#define Delay_us(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
#define Delay_ms(ms) Delay_us((ms)*1000L)
void Delay_100ns(void);
void Delay_200ns(void);
void FW_Reboot(int nProgMode);

#elif (_PLATFORM==PLF_EtherIP_2) // @@@@@@@@@@@@@@@@ #2
void Delay_us(t_ui32 usec);
void Delay_100ns(void);
void Delay_200ns(void);
#define Delay_ms(ms) Delay_us(ms*1000)
void FW_Reboot(int nProgMode);
t_bool GnIsModuleAvailable(t_ui16 uModNo, t_i16 *pnDevId); // 2009.11.06 ߰

#define McBSP0_DRR      0x18c0000   /* Address of data receive reg.         */
#define McBSP0_DXR      0x18c0004   /* Address of data transmit reg.        */
#define McBSP0_SPCR     0x18c0008   /* Address of serial port contl. reg.   */
#define McBSP0_RCR      0x18c000C   /* Address of receive control reg.      */
#define McBSP0_XCR      0x18c0010   /* Address of transmit control reg.     */
#define McBSP0_SRGR     0x18c0014   /* Address of sample rate generator     */
#define McBSP0_MCR      0x18c0018   /* Address of multichannel reg.         */
#define McBSP0_RCER     0x18c001C   /* Address of receive channel enable.   */
#define McBSP0_XCER     0x18c0020   /* Address of transmit channel enable.  */
#define McBSP0_PCR      0x18c0024   /* Address of pin control reg.          */

#endif // @@@@@@@@@@@@@@@@ #2

//************* Error codes *************************************//

#define cmERR_NONE					0
#define cmERR_MEM_ALLOC_FAIL		-290	// Memory allocation fail
#define cmERR_GLOBAL_MEM_FAIL		-292	// Global memory allocation fail
#define cmERR_ISR_CONNEC_FAIL 		-310	// ISR registration fail
#define cmERR_DIVIDE_BY_ZERO		-400	// Cause divide by zero error 
#define cmERR_WORNG_NUM_DATA		-500	// Number of data is too small or too big
#define cmERR_VER_MISMATCH			-600 	// Version(of file or device) mismatch
#define cmERR_FLASH_ERASE_FAIL		-601	// fail to erase a flash-memory sector
#define cmERR_FLASH_WRITE_FAIL		-602	// fail to write a flash-memory sector
#define cmERR_FLASH_COPYSECT_FAIL	-603	// fail to copy whole data from source sector to target sector
#define cmERR_FLASH_CANNOTMODIFY	-604	// cannot modify the sector
#define cmERR_INVALID_SYSCFG		-605	// TSysConfig, dwSign is not match with SYS_CFG_SIGN.
#define cmERR_MAXBYTESLIMIT_SYSCFG	-606	// TSysConfig, dwComment max bytes exceeded.

#define cmERR_INVALID_DEVICE_ID		-1010 // Invalid device id => Load Device or SetDeviceId()...
#define cmERR_INVALID_HANDLE		-1020
#define cmERR_UNSUPORTED_FUNC		-1030 
#define cmERR_INVALID_PARAMETER		-1101
#define cmERR_INVALID_CHANNEL		-1105
#define cmERR_INVALID_INPUT_RANGE	-1111 // Invalid range value (AI, AO)
#define cmERR_INVALID_FREQ_RANGE	-1121 // Invalid input or output frequency
#define	cmERR_FILE_CREATE_FAIL		-1501 // File create fail 
#define cmERR_FILE_OPEN_FAIL		-1511 // File open fail
#define cmERR_FILE_READ_FAIL		-1522 // File reading fail
#define cmERR_EVENT_CREATE_FAIL		-1550 // Event handle creation fail			
#define cmERR_INT_INSTANCE_FAIL		-1560 // Interrupt event instance creation fail
#define	cmERR_DITHREAD_CRE			-1570 // D/I state change monitor thread creation fail
#define cmERR_BUFFER_SMALL			-1580 // Buffer size is too small
#define cmERR_HIGH_TIMER_UNSUPP		-1590 // The installed hardware does not support a high-resolution performance counter (cmmUtlDelayMicroSec() function fails)
#define cmERR_OUT_OF_RANGE			-1600 // The range of some parameter is out of range
#define cmERR_WRONG_MODE			-1601 // 

#define cmERR_ON_MOTION				-5001
#define cmERR_STOP_BY_SLP			-5002 // Abnormally stopped by positive soft limit
#define cmERR_STOP_BY_SLN			-5003 // Abnormally stopped by negative soft limit
#define cmERR_STOP_BY_CMP3			-5004 // Abnormally stopped by comparator3
#define cmERR_STOP_BY_CMP4			-5005 // Abnormally stopped by comparator4
#define cmERR_STOP_BY_CMP5			-5006 // Abnormally stopped by comparator5
#define cmERR_STOP_BY_ELP			-5007 // Abnormally stopped by (+) external limit
#define cmERR_STOP_BY_ELN			-5008 // Abnormally stopped by (-) external limit
#define cmERR_STOP_BY_ALM			-5009 // Abnormally stopped by alarm input signal
#define	cmERR_STOP_BY_CSTP			-5010 // Abnormally stopped by CSTP input signal
#define cmERR_STOP_BY_CEMG			-5011 // Abnormally stopped by CEMG input signal
#define cmERR_STOP_BY_SD			-5012 // Abnormally stopped by SD input signal
#define cmERR_STOP_BY_DERROR		-5013 // Abnormally stopped by operation data error
#define cmERR_STOP_BY_IP			-5014 // Abnormally stopped by other axis error during interpolation
#define cmERR_STOP_BY_PO			-5015 // An overflow occurred in the PA/PB input buffer
#define cmERR_STOP_BY_AO			-5016 // Out of range position counter during interpolation
#define cmERR_STOP_BY_EE			-5017 // An EA/EB input error occurred (does not stop)
#define cmERR_STOP_BY_PE			-5018 // An PA/PB input error occurred (does not stop)
#define cmERR_STOP_BY_SLVERR		-5019 // Abnormally stopped because slave axis has been stopped
#define cmERR_STOP_BY_SEMG			-5020 // Abnormally stopped by software emergency setting

#define cmERR_MOT_MAOMODE			-5110 // Master output mode is not CW/CCW mode // during Master/Slave mode, Master output mode is not CW/CCW.
#define cmERR_MOT_SLAVE_SET			-5120 // Slave start fail (Motion state) cannot change into "Wait for Pulsar Input".
#define cmERR_SPEED_RANGE_OVER		-5130 // 
#define cmERR_INVALID_SPEED_SET		-5140 // Speed setting value is not valid
#define cmERR_ACC_LOW_LIMIT_OVER	-5142 // Acceleration setting value is too low
#define cmERR_ACC_HIGH_LIMIT_OVER	-5143 // Acceleration setting value is too high
#define cmERR_DEC_LOW_LIMIT_OVER	-5144 // Deceleration setting value is too low
#define cmERR_DEC_HIGH_LIMIT_OVER	-5145 // Deceleration setting value is too high
#define cmERR_INVALID_IXMAP			-5150 // Invalid interpolation map
#define cmERR_INVALID_LMMAP			-5160 // Invalid List-Motion Map 
#define cmERR_MOT_SEQ_SKIPPED		-5170 // Motion command is skipped because the axis is already running.  
#define cmERR_MOT_PREREG_FULL		-5180 // Motion command is skipped because the pre-register is full of an axis.
#define cmERR_LTC_QUE_SIZE_ERROR	-5190 // Specified latch-que size is too big.
#define cmERR_LTC_QUE_BUF_FREED		-5191 // Latch-que is not allocated.

#define	cmERR_UNKNOWN				-9999

#endif


