// mk_counter.h

#ifndef _MK_COUNTER_DEFINES_H_
#define _MK_COUNTER_DEFINES_H_

//  COUNTER ġ ε  //
typedef struct{
	HANDLE hDevice; // PC=>Device handle, DSP=>Base address
	t_i32 nNumCnt;
	t_i32 nCntIni;
	
	t_ui32 dwCntEnableMask;
	t_ui32 dwCntEdgeSelMask;
	t_ui32 dwCntFreqSelMask;
	
	t_i32 nReserved[3];
	
	struct{
		t_ui32 Id:	4; // Device ID
		t_ui32 Ver:	4; // H/W Version
		t_ui32 ModId: 4; // Module Id (͸ ġ  )
		t_ui32 ModType: 2; // Module Type (Unknown:0, UpDown Counter:1, Encoder Counter:2)
		t_ui32 Rsv:	18;
	}u;
}TCntDevice;

void cntBootup(void);
t_i32 cntGetVersion(void);

TCntDevice* cntGetDeviceDesc (t_ui16 uDevIdx);

t_bool	cntInitial (t_ui16 nNumDevs, TCntDevice aCntDevInfo[]);

t_i32	cntGetNumDevice (void);
t_bool	cntIsValidChan(t_ui16 nCntChan);
t_ui16	cntGetNumChannels();

// Counter  Լ.
t_i32 CntSetCounterEdgeOne(t_ui16 nChannel, t_i32 nEdgeMode); // nEdgeMode: 0(falling), 1(rising)
t_i32 CntGetCounterEdgeOne(t_ui16 nChannel);
t_i32 CntSetCounterEdgeMulti(t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwEdgeModeMask); // dwEdgeModeMask  Ʈ: 0(falling), 1(rising)
t_i32 CntGetCounterEdgeMulti(t_ui16 nIniChan, t_ui16 nNumChan);

t_i32 CntCounterClearOne(t_ui16 nChannel);
t_i32 CntCounterClearMulti(t_ui16 nIniChan, t_ui16 nNumChan);
t_i32 CntCounterClearAll();

t_i32 CntGetCount(t_ui16 nChannel);

t_i32 CntSetCounterEnableOne(t_ui16 nChannel, t_i32 nEnable);
t_i32 CntGetCounterEnableOne(t_ui16 nChannel);
t_i32 CntSetCounterEnableMulti(t_ui16 nIniChan, t_ui16 nNumChan, t_ui32 dwEnableMask);
t_i32 CntGetCounterEnableMulti(t_ui16 nIniChan, t_ui16 nNumChan);

t_i32 CntGetOverflowFlagOne(t_ui16 nChannel);
t_i32 CntGetOverflowFlagMulti(t_ui16 nIniChan, t_ui16 nNumChan);
t_i32 CntOverflowFlagClearOne(t_ui16 nChannel);
t_i32 CntOverflowFlagClearMulti(t_ui16 nIniChan, t_ui16 nNumChan);
t_i32 CntOverflowFlagClearAll();

t_i32	CntSetFilterFreq(t_ui16 nChannel, t_i32 FreqSel);
t_i32	CntGetFilterFreq(t_ui16 nChannel);

#endif //_MK_COUNTER_DEFINES_H_
