//================================================================================================================
// [mk_extern.c]
// - Version: 1.0.0.1
// - Update Data: 2007/08/08
// - Created by OYS
//================================================================================================================

#include "mk_common.h"
#include "mk_extdef.h"
#include "mk_motion.h"
#include "mk_dio.h"
#include "mk_net.h"
#include "mk_cnet.h"
#define _MK_EXTERN_C_
#include "mk_extgvar.h"
#include "mk_flash.h"
#include "mk_aio.h"

t_ui32 g_ulTimer = 0;

t_ui32 FW_GetVersion()
{
	return FW_VERSION;
}

unsigned char GetLastIpAddrFromGPIOF()
{
	t_i32 nAddrMsb, nAddrLsb, nCorrAddr;
	t_i32 *pnSwitchAddr = (t_i32 *)AM_SWITCH;
	nCorrAddr = (t_i32)(~*pnSwitchAddr & 0xff);

	nAddrMsb = ((nCorrAddr & 0xf) << 4) & 0xf0;
	nAddrLsb = ((nCorrAddr >> 4) & 0xf);

	nCorrAddr = nAddrMsb | nAddrLsb;
	return nCorrAddr;
}

//-------------------------------------------------------------------------------------------------------
void mkcBootup(void)
{
	flsBootup();
	
	mcBootup();			// Motion Modules Bootup
	dioBootup();		// Digital In/Out Modules Bootup
	g_uSerPortCnt = serBootupAll();		 // Serial Communication Modules Bootup (ceNM-PE & ceSC04A)

	aioBootup();  		// Analog In/Out Modules Bootup
	cnetdioBootup();	// ceCM01A & Its slaves (C-NET) Modules Bootup

	g_auIpAddr[3] = GetLastIpAddrFromGPIOF();    // Get Lottary Switch

	if(g_auIpAddr[3] > 0 && g_auIpAddr[3] < 255)
	{
		netBootup(g_auIpAddr);	// AM_ETHER = 0x2000
		Delay_ms(100);
	}
	commBootup(); // Common communication initialize
}

//-------------------------------------------------------------------------------------------------------
// mkcTimerTick(): return 1ms-unit timer tick
//-------------------------------------------------------------------------------------------------------
t_ui32 mkcTimerTick(void)
{
	return (g_ulTimer);
}

void mkcTimerTick_Set(t_ui32 dwSetValue)
{
	g_ulTimer = dwSetValue;
}

//-------------------------------------------------------------------------------------------------------
// mkcTimerCallback(): 1ms Timer Tick Generation
//-------------------------------------------------------------------------------------------------------
void mkcTimerCallback(void)
{	
	g_ulTimer++;
	
	if(mcAdvGetNumDevices() > 0){
		pclTimerCallback();		// this is only used with one or more motion modules.
	}
}
