//================================================================================================================
// [mk_net.h]: 
// -. Version: 1.06
// -. Update Data: 2007/11/22
// -. Created by OYS
// -. Revision history:
//   1 <Ver 1.0.0.4>: [2007/09/29] 
//    1) v1.0.0.3 mk_net.c _comnCommitTempQueTo() Լ UDP dest. IP Ǿ  ۽ŽϿ 
//          ʱȭϿµ   Ethernet.h sendto() Լ ϵ Ǿ.
//   2 <Ver 1.0.0.5>: [2007/11/16] 
//    1)   Լ ߰Ǿ.
//		serGetTimeout(), commGetTimeout()
//   3 <Ver 1.06>: [2007/11/22] 
//    1) UDP Ʈ 2 Ҷ ˼   ߻  : _netISR() Ethernet.h ϰ,
//          mk_net.c netISR() ̸ ȣϵ .
//   4 <Ver 1.0.0.7>: [2008/12/20]
//    1) SERIAL  Baud Rate 尡  Ǵ  , ȵǴ  ŵ.
//   5 <Ver 1.0.0.8>: [2009/02/24]
//    1) MAX_SOCK_NUM #define  ̰ Űܿ
//    2) ø TX  ũ  512..
//    3) commAsc_IsTxReady, commAsc_Commit Լ  ߰
//   6 <Ver 1.0.0.9>: [2009/02/26]
//    1) commAsc_CommitTo Լ  ߰
//   7 <Ver 1.0.1.0>: [2009/03/11]
//    1) netSend_KeepalivePacket Լ  ߰
//	 8 <Ver 1.0.1.1>: [2010/09/14]
//		1) ø   Լ  ߰ (Ʈ S/W RESET  ϵ ø  ̺귯  )
//			serInit, serBootupOne, serBootupAll
//================================================================================================================
#ifndef _MI_COMMON_NET_H_
#define _MI_COMMON_NET_H_

#include "mk_common.h"

#if (_PLATFORM==PLF_EtherIP_1)
#include "socket.h"
#endif

//******************************   ****************************************************************//

typedef enum _TCommProtocol{COMM_TCP=1, COMM_UDP, COMM_RS232, COMM_RS422, COMM_RS485} TCommProtocol;

#if	(_PLATFORM==PLF_EtherIP_2)
 #define MAX_ETHER_TX_SIZE	2048 // Max Ether TX buffer size (bytes)
 #define MAX_SER_TX_SIZE	512 // Max Serial TX buffer size (bytes)
#else
 #define MAX_ETHER_TX_SIZE	512 // Max Ether TX buffer size (bytes)
 #define MAX_SER_TX_SIZE	512 // Max Serial TX buffer size (bytes)
#endif

#if (_PLATFORM==PLF_EtherIP_1)
#define	MAX_SOCK_NUM		2	/**< Maxmium number of socket  */
#else
#define	MAX_SOCK_NUM		4	/**< Maxmium number of socket  */
#endif

typedef union{
	struct{
		t_ui32 uBaudRate; // Baud rate: {BAUD_2400, BAUD_3600, BAUD_4800, BAUD_7200, BAUD_9600, BAUD_19200, BAUD_38400, BAUD_56000}
		t_ui32 nDataBits; //  Ʈ.   8, 7, 6, 5   ̾ Ѵ.
		t_ui32 nStopBits; // Stop bits.   1 Ǵ 2̾ Ѵ.
		t_ui32 nParity; // Parity setting: 0=>disable parity check, 1=>odd parity,  2=>even parity
		t_ui32 dwReserved[16];
	}RS232;
	struct{
		t_ui32 uBaudRate; // Baud rate: {BAUD_2400, BAUD_3600, BAUD_4800, BAUD_7200, BAUD_9600, BAUD_19200, BAUD_38400, BAUD_56000}
		t_ui32 nDataBits; //  Ʈ.   8, 7, 6, 5   ̾ Ѵ.
		t_ui32 nStopBits; // Stop bits.   1 Ǵ 2̾ Ѵ.
		t_ui32 nParity; // Parity setting: 0=>disable parity check, 1=>odd parity,  2=>even parity
		t_ui32 dwReserved[16];
	}RS422;
	struct{
		t_ui32 uBaudRate; // Baud rate: {BAUD_2400, BAUD_3600, BAUD_4800, BAUD_7200, BAUD_9600, BAUD_19200, BAUD_38400, BAUD_56000}
		t_ui32 nDataBits; //  Ʈ.   8, 7, 6, 5   ̾ Ѵ.
		t_ui32 nStopBits; // Stop bits.   1 Ǵ 2̾ Ѵ.
		t_ui32 nParity; // Parity setting: 0=>disable parity check, 1=>odd parity,  2=>even parity
		t_ui32 dwReserved[16];
	}RS485;
	struct{
		t_ui32 uLocalPort;
		t_ui32 uHostPort;
		///////////////////////////////////////////////////////////////////////////////
		// uSockFlag: designate option to be used in appropriate. set 0 in general case.
		// this value can be a combination of any of followings,
		// SOCKOPT_BROADCAST(0x80) -> Send/receive broadcast message in UDP
		// SOCKOPT_NDTIMEOUT(0x40) -> Use register value which designated TIMEOUT value
		// SOCKOPT_NDACK(0x20)     -> When not using no delayed ack
		// SOCKOPT_SWS(0x10)       -> When not using silly window syndrome
		t_ui32 uSockFlag; 
		t_ui32 dwReserved[17];
	}UDP;
	struct{
		t_ui32 uLocalPort;
		t_ui32 uHostPort;
		t_ui32 uSockFlag; 
		t_ui32 bIsServer; // 0->client,  1->server
		TSockAddr HostIp;
		t_ui32 dwReserved[16];
	}TCP;
}TCommOpenInfo;

// 2009.02.16 ߰.
#if (_PLATFORM == PLF_EtherIP_2)
typedef struct{
	t_char *pBuf;
}TByteBuf;

typedef struct{
	t_bool bIsTrged;
	t_char *pBuf;
	t_ui32 uTargSize;
	t_ui32 uSentSize;
}TCommitAsync;
#endif

//****************************** SERIAL  **************************************************************//
// 2008.12.20 modified by johyun :  ϴ BAUD RATE  .
enum {BAUD_2400, BAUD_4800, BAUD_9600, BAUD_14400, BAUD_19200, BAUD_38400, BAUD_57600, BAUD_115200};

//****************************** ETHERNET  ************************************************************//

#define	SOCK_CLOSEDM		0x00 	// unused socket
#define	SOCK_STREAM			0x01	// TCP
#define	SOCK_DGRAM			0x02	// UDP
#define	SOCK_IPL_RAW		0x03	// IP LAYER RAW SOCK
#define	SOCK_MACL_RAW		0x04	// MAC LAYER RAW SOCK

/* SOCKET OPTION */
#define SOCKOPT_BROADCAST	0x80	// Transmission, Reception of broadcasting data
#define SOCKOPT_NDTIMEOUT	0x40	// Setting timeout
#define SOCKOPT_NDACK		0x20	// Setting No Delayed Ack(TCP)
#define SOCKOPT_SWS			0x10	// Setting Silly Window Syndrome(TCP)

/* Select parameter to use */
#define SEL_CONTROL		0	// Confirm socket status
#define SEL_SEND		1	// Confirm Tx free buffer size
#define SEL_RECV		2	// Confirm Rx data size

/* Socket Status Vabiables */

#if	(_PLATFORM==PLF_miCUBE || _PLATFORM==PLF_miCUBE_E)
// for W3100A
#define SOCK_CLOSED		0x00		// Status of connection closed
#define SOCK_ARP		0x01		// Status of ARP
#define SOCK_LISTEN		0x02		// Status of waiting for TCP connection setup
#define SOCK_SYNSENT		0x03		// Status of setting up TCP connection
#define SOCK_SYNSENT_ACK	0x04		// Status of setting up TCP connection
#define SOCK_SYNRECV		0x05		// Status of setting up TCP connection
#define SOCK_ESTABLISHED	0x06		// Status of TCP connection established
#define SOCK_CLOSE_WAIT		0x07		// Status of closing TCP connection
#define SOCK_LAST_ACK		0x08		// Status of closing TCP connection
#define SOCK_FIN_WAIT1		0x09		// Status of closing TCP connection
#define SOCK_FIN_WAIT2		0x0A		// Status of closing TCP connection
#define SOCK_CLOSING		0x0B		// Status of closing TCP connection
#define SOCK_TIME_WAIT		0x0C		// Status of closing TCP connection
#define SOCK_RESET		0x0D		// Status of closing TCP connection
#define SOCK_INIT		0x0E		// Status of socket initialization
#define SOCK_UDP		0x0F		// Status of UDP
#define SOCK_RAW		0x10		// Status of IP RAW

#elif (_PLATFORM==PLF_EtherIP_1 || _PLATFORM==PLF_EtherIP_2)
// for W5100
#define SOCK_CLOSED				0x00		/**< closed */
#define SOCK_INIT 				0x13		/**< init state */
#define SOCK_LISTEN				0x14		/**< listen state */
#define SOCK_SYNSENT	   		0x15		/**< connection state */
#define SOCK_SYNRECV		   	0x16		/**< connection state */
#define SOCK_ESTABLISHED		0x17		/**< success to connect */
#define SOCK_FIN_WAIT			0x18		/**< closing state */
#define SOCK_CLOSING		   	0x1A		/**< closing state */
#define SOCK_TIME_WAIT			0x1B		/**< closing state */
#define SOCK_CLOSE_WAIT			0x1C		/**< closing state */
#define SOCK_LAST_ACK			0x1D		/**< closing state */
#define SOCK_UDP				0x22		/**< udp socket */
#define SOCK_IPRAW			   	0x32		/**< ip raw mode socket */
#define SOCK_MACRAW			   	0x42		/**< mac raw mode socket */
#define SOCK_PPPOE				0x5F		/**< pppoe socket */

#else
#endif

void 	serInit();
t_bool 	serBootupOne(t_ui16 uPort, t_bool bReallocAsyncMem);
t_ui16	serBootupAll (void);
void	serOpenPort (t_i32 nChannel, t_i32 nSerType, t_i32 nBaudId, t_i32 nDataBits, t_i32 nStopBits, t_i32 nParity);
void	serClosePort (t_i32 nChannel);
void	serSetTimeout (t_i32 nChannel, t_ui32 to);
t_ui32	serGetTimeout(t_i32 nPort);
t_bool	serIsDataReady (t_i32 Channel);
t_bool	serWriteByte (t_i32 nChannel, t_byte bData);
t_bool	serReadByte (t_i32 nChannel, void* pBuffer);
t_ui32	serGetUnreadSize (t_i32 nChannel);
t_bool	serCheckError (t_i32 nChannel, t_bool bDisableInt);
t_ui16  serErrorStatus(t_i32 nPort, t_bool bDisableInt);
void	serISR (t_i32 nChannel);

t_i32 	netGetVersion(void);
void	netBootup (t_uchar addr[]);
void	netSetSubnet (t_uchar * uAddr);
void	netSetGateway (t_uchar * uAddr);
void	netSetIP (t_uchar * uAddr);
t_i32	netOpenSocket (t_ui32 uChannel, t_ui32 uProtocol, t_ui32 uPort, t_ui32 uFlag);
t_i32	netConnect (t_ui32 uChannel, t_uchar * uAddr, t_ui32 uPort);
void 	netDisconnect(t_ui32 uChannel);
void	netClose(t_ui32 uChannel);
t_bool	netListen(t_ui32 uChannel);
void	netSetTimeout(t_ui32 uTimeValue, t_ui32 uRetryCnt);
void	netGetTimeout(t_ui32* puTimeValue, t_ui32* puRetryCnt);
t_ui32	netSelect (t_ui32 uChannel, t_ui32 nSelType);
t_i32	netSend (t_ui32 uChannel, const void* pBuf, t_ui32 uSizeAsByte, t_bool bIs32bitPack);
t_i32	netRecv (t_ui32 uChannel, void* pBuf, t_ui32 uSizeAsByte, t_bool bIs32bitPack);
t_ui32	netSendTo (t_ui32 uChannel, const t_uchar* pBuf, t_ui32 uSize, t_uchar * uAddr, t_ui32 uPort);
t_ui32	netRecvFrom (t_ui32 uChannel, t_uchar* pBuf, t_ui32 uSize, t_uchar* uAddr, t_ui32* uPort);
void	netISR(void);
void 	netSend_KeepalivePacket(t_ui32 uChannel); // 2009.03.11 ߰

void	commBootup (void);
void	commOpenPort (t_i32 nSockType, t_i32 nChannel, TCommProtocol CommProtocol, TCommOpenInfo* pCOI);
void	commClosePort(t_i32 nSockType, t_i32 nChannel); // [NEW][07/09/17]
void	commGetPeerInfo(t_i32 nSockType, t_i32 nChannel, t_uchar abyHostIp[], t_ui32 *pnPort); // [NEW][07/09/15]
void	commSetTimeout (t_i32 nSockType, t_i32 nChannel, t_ui32 dwTimeOut);
t_ui32	commGetTimeout(t_i32 nSockType, t_i32 nChannel);
void	commRxReset (t_i32 nSockType, t_i32 nChannel);
void	commTxReset (t_i32 nSockType, t_i32 nChannel);
t_bool	commIsDataReady (t_i32 nSockType, t_i32 nChannel);
t_ui32	commGetUnreadSize (t_i32 nSockType, t_i32 nChannel);
t_bool	commPeekByte(t_i32 nSockType, t_i32 nChannel, t_byte* pbyRetVal);
t_bool	commPeekByteEx(t_i32 nSockType, t_i32 nChannel, t_byte* pbyRetVal, t_i32 nIndex); // [NEW][07/09/15]
t_bool	commReadByte (t_i32 nSockType, t_i32 nChannel, void* pBuffer);
t_bool	commWriteByte (t_i32 nSockType, t_i32 nChannel, t_byte bData);
t_i32	commPeekString(t_i32 nSockType, t_i32 nChannel, t_char* pBuffer, t_ui32 nNumBytes); // [NEW][07/09/15]
t_i32	commReadString (t_i32 nSockType, t_i32 nChannel, t_char* pBuffer, t_ui32 nNumBytes);
t_i32	commWriteString (t_i32 nSockType, t_i32 nChannel, t_char* pBuffer, t_i32 nNumBytes);
t_i32	commReadDword (t_i32 nSockType, t_i32 nChannel, t_i32 *pBuffer, t_ui32 nNumDwords);
t_i32	commWriteDword (t_i32 nSockType, t_i32 nChannel, t_i32 *pBuffer, t_ui32 nNumDwords);
t_i32	commWriteDword_(t_i32 nSockType, t_i32 nChannel, t_i32 dwData); // [NEW][07/09/15]
t_i32	commCommit (t_i32 nSockType, t_i32 nChannel);
t_i32	commCommitTo(t_i32 nSockType, t_i32 nChannel, t_uchar abyIpAddr[], t_ui32 nUdpPort); // [NEW][07/09/15]
t_bool 	commAsc_IsTxReady(t_i32 nSockType, t_i32 nChannel); // [NEW][09/02/16]
t_bool	commAsc_Commit(t_i32 nSockType, t_i32 nChannel); // [NEW][09/02/16]
t_bool	commAsc_CommitTo(t_i32 nSockType, t_i32 nChannel, t_uchar abyIpAddr[], t_ui32 nUdpPort); // [NEW][09/02/26]

//******************************   ************************************************************//

// Ϲ   //
#define GC_SOH	0x01
#define GC_STX	0x02
#define GC_ETX	0x03
#define GC_EOT	0x04
#define GC_ENQ	0x05
#define GC_ACK	0x06
#define GC_NAK	0x15


//*****************************  ڵ  ********************************************************//

#define ccERR_NONE				0
#define ccERR_INVALID_PORT_NO	-10 // Ʈ ȣ ùٸ ʴ.
#define ccERR_OPEN_PORT_FAIL	-20 // Ʈ openϴµ ߴ.
#define ccERR_EOT_MISS			-30 // EOT Ͱ ŵ ʾҴ.
#define ccERR_ACK_MISS			-40 // EOT Ͱ ŵ ʾҴ.
#define ccERR_ENQ_MISS			-50 // EOT Ͱ ŵ ʾҴ.
#define ccERR_RX_TIMEOUT		-60 //  ðʰ
#define ccERR_CHKSUM_MISMATCH	-70 // üũ Ͱ ġ ʴ´.		
#define ccERR_INVALID_DATA		-80 // ŵ Ͱ  Ϳ ġ ʴ´.	

#endif
